/*
 * Random track MP3 player, controlled by an Arduino Nano
 * MP3-Player : DF-Player module
 * Conection is shown in the schematic in this folder
 * 
 * The SD card needs a particular folder structure: /mp3/0000.mp3
 *                                                       0001.mp3
 *                                                       0002.mp3
 *                                                       ... .mp3
 */ 
#include <SoftwareSerial.h>
SoftwareSerial softSerial(10, 11);
#define FPSerial softSerial


#include "DFRobotDFPlayerMini.h"
DFRobotDFPlayerMini myDFPlayer;


#define BUTTON 9

int track = 1;
int fileCounts = 0;

//============================================================================= SETUP
void setup()
{
  
  pinMode(BUTTON, INPUT_PULLUP);  
  
  Serial.begin(115200);
  Serial.println();
  Serial.println("MP3 Player Frankfurt");
  unsigned long a = analogRead(0) + analogRead(1) + analogRead(2) + analogRead(3) + analogRead(4) + analogRead(5);
  Serial.println("RND Seed: ");
  Serial.println(a);
  randomSeed(a);
  Serial.println("Setup softserial");
  FPSerial.begin(9600);
  Serial.println("Setup I/O's");
  
  Serial.println("Setup mp3 player");
  if (!myDFPlayer.begin(FPSerial, /*isACK = */true, /*doReset = */true)) {  //Use serial to communicate with mp3.
    Serial.println(F("Unable to begin:"));
    Serial.println(F("1.Please recheck the connection!"));
    Serial.println(F("2.Please insert the SD card!"));
    while (true) {
      delay(0); // Code to compatible with ESP8266 watch dog.
    }
  }
  Serial.println(F("DFPlayer Mini online."));
  myDFPlayer.volume(18);  //Set volume value. From 0 to 30
  myDFPlayer.readFileCounts();
  fileCounts = myDFPlayer.readFileCountsInFolder(0);
  Serial.print(fileCounts);
  Serial.println(" Files detected");

  Serial.println("Setup done :)");
  Serial.println("---------------");
 
}


//============================================================================= LOOP
void loop()
{
  digitalWrite(13, (millis() / 500) % 2); 
  if (digitalRead(BUTTON)) {frage(); delay(1000); while (digitalRead(BUTTON));delay(500);}
}

//============================================================================= FUNCTIONS
void frage() {
  
  track+= random(1, fileCounts-3);
  track = track % fileCounts;
  if (track == 0)track = 1;
  myDFPlayer.play(track);  //play mp3 track 
  Serial.println();
  Serial.print("Playing track ");
  Serial.println(track);
  delay(2000);
}
 
 
